#@<OUT> Help on Type
NAME
      Type - Data type constants.

SYNTAX
      mysqlx.Type

DESCRIPTION
      The data type constants assigned to a Column object retrieved through
      RowResult.get_columns().

PROPERTIES
      BIGINT
            A large integer.

      BIT
            A bit-value type.

      BYTES
            A binary string.

      DATE
            A date.

      DATETIME
            A date and time combination.

      DECIMAL
            A packed "exact" fixed-point number.

      ENUM
            An enumeration.

      FLOAT
            A floating-point number.

      GEOMETRY
            A geometry type.

      INT
            A normal-size integer.

      JSON
            A JSON-format string.

      MEDIUMINT
            A medium-sized integer.

      SET
            A set.

      SMALLINT
            A small integer.

      STRING
            A character string.

      TIME
            A time.

      TINYINT
            A very small integer.

FUNCTIONS
      help([member])
            Provides help about this object and it's members

#@<OUT> Help on Type.BIGINT
NAME
      BIGINT - A large integer.

SYNTAX
      Type.BIGINT

#@<OUT> Help on Type.BIT
NAME
      BIT - A bit-value type.

SYNTAX
      Type.BIT

#@<OUT> Help on Type.BYTES
NAME
      BYTES - A binary string.

SYNTAX
      Type.BYTES

#@<OUT> Help on Type.DATE
NAME
      DATE - A date.

SYNTAX
      Type.DATE

#@<OUT> Help on Type.DATETIME
NAME
      DATETIME - A date and time combination.

SYNTAX
      Type.DATETIME

#@<OUT> Help on Type.DECIMAL
NAME
      DECIMAL - A packed "exact" fixed-point number.

SYNTAX
      Type.DECIMAL

#@<OUT> Help on Type.ENUM
NAME
      ENUM - An enumeration.

SYNTAX
      Type.ENUM

#@<OUT> Help on Type.FLOAT
NAME
      FLOAT - A floating-point number.

SYNTAX
      Type.FLOAT

#@<OUT> Help on Type.GEOMETRY
NAME
      GEOMETRY - A geometry type.

SYNTAX
      Type.GEOMETRY

#@<OUT> Help on Type.INT
NAME
      INT - A normal-size integer.

SYNTAX
      Type.INT

#@<OUT> Help on Type.JSON
NAME
      JSON - A JSON-format string.

SYNTAX
      Type.JSON

#@<OUT> Help on Type.MEDIUMINT
NAME
      MEDIUMINT - A medium-sized integer.

SYNTAX
      Type.MEDIUMINT

#@<OUT> Help on Type.SET
NAME
      SET - A set.

SYNTAX
      Type.SET

#@<OUT> Help on Type.SMALLINT
NAME
      SMALLINT - A small integer.

SYNTAX
      Type.SMALLINT

#@<OUT> Help on Type.STRING
NAME
      STRING - A character string.

SYNTAX
      Type.STRING

#@<OUT> Help on Type.TIME
NAME
      TIME - A time.

SYNTAX
      Type.TIME

#@<OUT> Help on Type.TINYINT
NAME
      TINYINT - A very small integer.

SYNTAX
      Type.TINYINT

#@<OUT> Help on Type.help
NAME
      help - Provides help about this object and it's members

SYNTAX
      Type.help([member])

WHERE
      member: If specified, provides detailed information on the given member.
